# Support code that may be used in debian/rules
# Alastair McKinstry <mckinstry@debian.org>
# 2023-12-30

include /usr/share/dpkg/architecture.mk

# WARNING: THIS CODE IS EXPERIMENTAL AND IN HIGH FLUX

# This will set:
#    FC_DEFAULT : the default compiler flavour
#    FC_OPTIONAL : a space seperated list of compiler flavours present

# FC_DEFAULT is /etc/alternatives/f95 unless FC is specified in the environment

FC_OPTIONAL=

ifeq ($(origin F77),default)
  F77:=$(shell basename $(shell readlink /etc/alternatives/f77))
endif
ifeq ($(origin FC),environment)
  FC_DEFAULT:=$(FC)
endif
ifeq ($(origin FC),default)
  FC_DEFAULT:=$(shell basename $(shell readlink /etc/alternatives/f95))
endif

# FC flavours: shortnames for Fortran compilers
#  gfortran flang flangext lfortran

# Functions: take flavour as parameter

# get_fc_abi
#   return a shortname for the ABI
# get_flibdir()

# get_fmoddir:
#   return the Module(s)directory usable by this flavour

fort_root = /usr/lib/${DEB_HOST_MULTIARCH}/fortran

# Install in this directory
get_fmoddir = $(if $(filter $1,gfortran), "${fort_root}/gfortran-mod-15", \
              $(if $(filter $1,flang), "${fort_root}/flang-mod-15", \
              $(if $(filter $1, flangext), "${fort_root}/flangext-mod-15", \
		FORTRAN_FLAVOUR_UNDEFINED )))

# Compatible modules for include search. Directories may not be present
get_fmoddirs = $(if $(filter $1,gfortran), -I${fort_root}/gfortran-mod-15 -I${fort_root}/flangext-mod-15, \
               $(if $(filter $1,flang), -I${fort_root}/flang-mod-15, \
               $(if $(filter $1, flangext), -I${fort_root}/flangext-mod-15 -I${fort_root}/gfortran-mod-15, \
		FORTRAN_FLAVOUR_UNDEFINED )))
# get_fc_exe
#   Return the fully-qualified path

get_fc_exe = $(if $(filter $1,gfortran), "/usr/bin/gfortran-13", \
             $(if $(filter $1,flang),    "/usr/bin/flang-new-17", \
             $(if $(filter $1,flangext), "/usr/bin/flang-to-external-fc-17", \
               FORTRAN_FLAVOUR_UNDEFINED )))

get_flibdir = "/usr/lib/${DEB_HOST_MULTIARCH}/fortran/$1"

# Compatible directories for library search. Directories may not be present
get_flibdirs = $(if $(filter $1,gfortran), -L${fort_root}/gfortran -L${fort_root}/flangext, \
               $(if $(filter $1,flang), -L${fort_root}/flang, \
               $(if $(filter $1, flangext), -L${fort_root}/flangext -L${fort_root}/gfortran, \
               FORTRAN_FLAVOUR_UNDEFINED )))


# See #957692
GF10_FLAGS:=$(if $(filter $(shell readlink /usr/bin/gfortran), gfortran-10), \
                 -fallow-invalid-boz -fallow-argument-mismatch, )
FFLAGS=$(shell dpkg-buildflags --get FFLAGS) $(GF10_FLAGS)

# Abbreviated names for potentially available Fortran compilers

# Potentially add others if $FC is set (eg ifx, Arm)

# FC_COMPILERS:= gfortran flang-new-17 flang-to-external-fc-17 lfortran
# FC_COMPILERS:= gfortran flang flangext lfortran

